



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用 vue-cli 实现组件之间数据交换</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用 vue-cli 实现组件之间数据交换</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 21:00:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1 使用脚手架工具用 webpack 模板初始化项目，用 webstorm 打开项目。src 目录下是要编写的源文件。</p>
<p>main.js 文件 是主入口文件，</p>
<p>在es6语法中，：function(){}可以简写为(){}</p>
<p>在vue-cli中定义data时，不再是对象，而是以function函数的形式返回对象</p>
<p>template模板下只能有一个子节点，否则会报错</p>
<p>我将 App.vue 改名为TodoList.vue 因此修改 main.js 文件，</p>
<div>
<pre class="prettyprint linenums">import TodoList from './TodoList'<br />
...<br />
components: {<br />
    todoList:TodoList<br />
  },</pre>
</div>
<p>main.js 文件内容如下</p>
<div>
<div>
<pre class="prettyprint linenums">// The Vue build version to load with the `import` command<br />
// (runtime-only or standalone) has been set in webpack.base.conf with an alias.<br />
import Vue from 'vue'<br />
import TodoList from './TodoList'

Vue.config.productionTip = false

/* eslint-disable no-new */<br />
new Vue({<br />
  el: '#app',<br />
  components: {<br />
    todoList:TodoList<br />
  },<br />
  template: '&lt;todoList&gt;&lt;/todoList&gt;'<br />
})</pre>
</div>
</div>
<p>2 组件的属性内容现在写到 export default{} 对象中</p>
<p>在 vue 文件中将模板放在 &lt;template&gt; 标签下</p>
<p>将脚本内容放到 &lt;script&gt; 标签下</p>
<p>TodoList 组件内容如下</p>
<div>
<pre class="prettyprint linenums">&lt;template&gt;<br />
  &lt;div&gt;<br />
    &lt;input v-model="inputValue"/&gt;<br />
    &lt;button @click="addItem"&gt;提交&lt;/button&gt;<br />
    &lt;ul&gt;<br />
      &lt;todo-item<br />
        v-for="(item, index) of todoList"<br />
        :key="index" :content="item"<br />
        :index="index"<br />
        @deleteItem="deleteItem"<br />
      &gt;

      &lt;/todo-item&gt;

    &lt;/ul&gt;<br />
  &lt;/div&gt;<br />
&lt;/template&gt;

&lt;script&gt;<br />
import TodoItem from './components/TodoItem'

export default {<br />
  components: {<br />
    'todo-item':TodoItem<br />
  },<br />
  data () {<br />
    return {<br />
      inputValue: '',<br />
      todoList: []<br />
    }<br />
  },<br />
  methods:{<br />
    addItem () {<br />
      this.todoList.push(this.inputValue);<br />
      this.inputValue= '';<br />
    },<br />
    deleteItem (index) {<br />
      this.todoList.splice(index,);<br />
    }<br />
  }

}<br />
&lt;/script&gt;

&lt;style&gt;<br />
&lt;/style&gt;</pre>
</div>
<p>在该组件中引用了 TodoItem 组件。在本组件中需要引入该组件， 使用 components 属性，引用一个对象。该对象的键是在该组件的名称，值是引用的组件名称。</p>
<p>对于 <code>components</code> 对象中的每个属性来说，其属性名就是自定义元素的名字，其属性值就是这个组件的选项对象。</p>
<p>3 子组件写法和上面一样</p>
<p>TodoItem.vue 文件内容如下</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;template&gt;<br />
  &lt;li v-text="content" @click="deleteItem"&gt;&lt;/li&gt;<br />
&lt;/template&gt;

&lt;script&gt;<br />
export default {<br />
  props:['content','index'],<br />
  methods: {<br />
    deleteItem () {<br />
      this.$emit('deleteItem',this.index);

    }<br />
  }<br />
}<br />
&lt;/script&gt;

&lt;!-- Add "scoped" attribute to limit CSS to this component only --&gt;<br />
&lt;style scoped&gt;<br />
&lt;/style&gt;</pre>
</div>
</div>
<p>4 父子组件之间传递消息的方式和之前的博文一致。参看</p>
<p><a href="https://www.cnblogs.com/zhaopengcheng/p/9374575.html" rel="external nofollow noreferrer">Vue 中组件概念</a></p>
<p>5 最后的效果如下</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/852501/201807/852501-20180728150047777-599050586.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn4nn28.html">Oracle IF &amp;amp&semi; CASE语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gwly78.html">伸展树&lpar;二&rpar;之 C&plus;&plus;的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q76kyx8.html">poj1733Parity game</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j01k10q.html">OSChina中远程GIT仓库同步探索</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1r0lv9.html">CMSIS RTOS -- embOS segger</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok2n4x9.html">ORA-12154 TNS无法解析指定的连接标识符</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm05579.html">&lbrack;Caffe&rsqb; ubuntu14&period;04下使用OpenBLAS加速Caffe</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjrkjk9.html">mirantis fuel</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oe2439.html">基于live555的一个简单RTSP服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x2l4v8.html">hibernate中load&comma;get&semi;find&comma;iterator&semi;merge&comma;saveOrUpdate&comma;lock的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojk5zxq.html">uva 11732 - strcmp&lpar;&rpar; Anyone&quest;  不错的Trie题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyd2dk9.html">&lbrack;物理学与PDEs&rsqb;第3章习题1 只有一个非零分量的磁场</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp66xjq.html">Monkey之常用ADB命令（新猿旺学习总结）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvj7or8.html">20175229张智敏 Arrays和String单元测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwp67v9.html">orm单表查询和模糊查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwyeed8.html">ubuntu14&period;04 VIM for python 一键配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jvzj3q.html">迭代器模式（java版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4lkdm9.html">build custom centos7</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4gdde9.html">windows 常用dos命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/953kjg68.html">修改Gradle 和Maven本地仓库的位置方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/ql1jzz69.html">Java本地运行中文正常，部署到Weblogic中文乱码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve254y9.html">linux cp 命令详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvy11dq.html">Android Things专题 1&period;前世今生</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vrr75q.html">〖Android〗快速部署SSHD和Bash Shell（程序：DroidSSHD和BetterTerminalEmulatorPro）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pjje5q.html">【PMP】资源平衡与资源平滑</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkykj38.html">奥比中光3D视觉传感器--OpenNI 2配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4140xq.html">python之模块datetime详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o41dx1q.html">Windows2008&vert;2003超出最大连接数</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k5mmoq.html">转&colon;Ogre的MaterialSystem分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/953gwgm8.html">vmware与virtualbox之对比分析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
